package il.ac.tau.cs.sw1.ex4;

import java.util.Arrays;
import java.util.Scanner;

public class SpellingCorrectorTest {
	public static void main(String[] args){
		
		//sentence splitting/building
		String e1 = "this is a test";
		String[] words = SpellingCorrector.splitSentence(e1);
		if (!Arrays.equals(words, new String[] {"this", "is", "a", "test"})){
			System.out.println("ERROR1");
		}
		String sent1 = SpellingCorrector.buildSentence(new String[] {"this", "is", "a", "test"});
		if (!sent1.equals(e1)){
			System.out.println("ERROR2");
		}
		
		//vocabulary
		String vocString = "this is a test it 123";
		Scanner vocScanner = new Scanner(vocString); //this scanner read the content of e1
		String[] vocabulary = SpellingCorrector.loadVocabulary(vocScanner);
		vocScanner.close();
		if (!Arrays.equals(vocabulary, new String[] {"a", "is", "it", "test", "this"})){
			System.out.println("ERROR3");
		}
		if (!SpellingCorrector.isInVocabulary(vocabulary, "a")){
			System.out.println("ERROR4");
		}
		
		//corrections
		String correctionsString = "a: b c d i f\ni: a\nb: d e";
		Scanner correctionsScanner = new Scanner(correctionsString);
		char[][] corrections = SpellingCorrector.loadCorrections(correctionsScanner);
		if (corrections.length != 26){
			System.out.println("ERROR5");
		}
		if (!Arrays.equals(corrections[1], new char[] {'d', 'e'})){
			System.out.println("ERROR6");
		}
		
		//candidates for corrections:
		if(!Arrays.equals(SpellingCorrector.getPossibleCorrections("at", vocabulary, corrections), new String[] {"it"})){
			System.out.println("ERROR7");
		}
		System.out.println("Done!");

	}
}
